# Create interest plan version Create a new version of an existing interest plan. This endpoint allows you to update specific fields while preserving others from the previous version. Key features: - Creates a new version with the specified `start_date`. - Updates only the provided fields—any field not specified inherits the value from the previous version. - Validates that the new `start_date` is after the `start_date` of the previous version. - Maintains immutable fields like `interest_type` and `tier_calculation`. - Preserves existing tiers when updating `interest_by_tiers`—only specified tiers are updated. This endpoint generates an [Interest plan created](https://developers.pismo.io/events/docs/interest-engine-interest-plan-creation-success-1) event. # OpenAPI definition ```json { "openapi": "3.1.0", "info": { "title": "Banking - Interest engine", "version": "1.0.0", "description": "API to handle interest-bearing account operations", "termsOfService": "https://developers.pismo.io/terms/", "contact": { "name": "API Support", "url": "https://developers.pismolabs.io/pismo-docs/docs/support" }, "license": { "name": "Copyright Pismo" } }, "servers": [ { "url": "https://sandbox.pismolabs.io/interest-engine", "description": "Sandbox API server for testing" }, { "url": "https://sandbox.pismolabs.io/passport/v2/s2s/access-token", "description": "Sandbox API for oauth2" } ], "tags": [ { "name": "Interest engine", "description": "Manage interest plans" } ], "components": { "parameters": { "Authorization": { "name": "authorization", "in": "header", "description": "Authorization", "required": true, "example": "Bearer YOUR_BEARER_TOKEN", "schema": { "type": "string" } }, "ContentType": { "name": "content-type", "in": "header", "description": "Content type", "required": true, "example": "application/json", "schema": { "type": "string" } }, "InterestPlanIdPath": { "name": "interestPlanId", "in": "path", "description": "Interest plan ID generated during the plan's creation. Must be an alphanumeric UUID with the alphabetical characters in lowercase.", "required": true, "example": "d9b2c9e1-4633-4a10-841b-270f7f1493cd", "schema": { "type": "string" } } }, "schemas": { "Amount": { "type": "number", "format": "double", "description": "Amount in the `interest_by_tier`", "example": 1000 }, "CapEffectiveRate": { "type": "number", "format": "double", "description": "Cap effective rate. If you provide a value for `cap_effective_rate`, you must also provide a value for `cap_threshold`.", "example": 1.2 }, "CapThreshold": { "type": "number", "format": "double", "description": "Cap threshold value. If you provide a value for `cap_threshold`, you must also provide a value for `cap_effective_rate`.", "example": 1.1 }, "Days": { "type": "integer", "format": "int32", "description": "Number of days in `interest_by_tier`", "example": 30 }, "Description": { "type": "string", "description": "Interest plan name", "example": "Banking plan" }, "FixedInterestRate": { "type": "number", "format": "float", "description": "Fixed annual interest rate for investments or deposits. If a `benchmark` value is provided, this field must be null.", "example": 0.1 }, "FloorEffectiveRate": { "type": "number", "format": "double", "description": "Floor effective rate", "example": 2.2 }, "FloorThreshold": { "type": "number", "format": "double", "description": "Floor threshold value", "example": 2.1 }, "InterestByTiers": { "type": "object", "properties": { "type": { "$ref": "#/components/schemas/InterestByTiersType" }, "tier_calculation": { "$ref": "#/components/schemas/TierCalculation" }, "tiers": { "type": "array", "items": { "$ref": "#/components/schemas/InterestByTiersArrayObject" } } }, "required": [ "type", "tier_calculation", "tiers" ], "description": "Interest by tiers configuration", "example": { "type": "TERM", "tier_calculation": "RETROACTIVE", "tiers": [ { "days": 30, "amount": 1000, "margin_rate": 1, "fixed_interest_rate": 1.2 }, { "days": 60, "amount": 2000, "margin_rate": 1, "fixed_interest_rate": 1.3 } ] } }, "InterestByTiersArrayObject": { "type": "object", "properties": { "days": { "$ref": "#/components/schemas/Days" }, "amount": { "$ref": "#/components/schemas/Amount" }, "margin_rate": { "$ref": "#/components/schemas/MarginRate" }, "fixed_interest_rate": { "$ref": "#/components/schemas/FixedInterestRate" } }, "description": "Tier details for interest calculation" }, "InterestByTiersType": { "type": "string", "description": "Interest type\n- `TERM`: Interest rate varies according to the period of time since the deposit was made.\n- `AMOUNT`: Interest rate varies according to the current balance.\n", "enum": [ "TERM", "AMOUNT" ], "example": "TERM" }, "InterestPlanId": { "type": "string", "format": "UUID", "description": "Interest plan ID generated during the plan's creation. Must be an alphanumeric UUID with the alphabetical characters in lowercase.", "example": "07d84f79-3027-47bd-b628-65528ccc8fb2" }, "InterestPlanVersionRequest": { "title": "Interest plan version request", "type": "object", "properties": { "start_date": { "$ref": "#/components/schemas/StartDateForNewVersion" }, "description": { "$ref": "#/components/schemas/Description" }, "fixed_interest_rate": { "$ref": "#/components/schemas/FixedInterestRate" }, "margin": { "$ref": "#/components/schemas/Margin" }, "margin_rate": { "$ref": "#/components/schemas/MarginRate" }, "interest_by_tiers": { "$ref": "#/components/schemas/InterestByTiers" }, "interest_thresholds": { "$ref": "#/components/schemas/InterestThresholds" } }, "required": [ "start_date" ], "example": { "start_date": "2025-06-17", "description": "BANKING PLAN v2", "margin": 0.05, "margin_rate": 1.2 } }, "InterestPlanVersionResponse": { "title": "Interest plan version response", "type": "object", "properties": { "interest_plan_id": { "$ref": "#/components/schemas/InterestPlanId" }, "version": { "type": "string", "description": "ID for the new interest plan version", "example": "2025-06-17" } } }, "InterestThresholds": { "type": "object", "properties": { "cap_threshold": { "$ref": "#/components/schemas/CapThreshold" }, "cap_effective_rate": { "$ref": "#/components/schemas/CapEffectiveRate" }, "floor_threshold": { "$ref": "#/components/schemas/FloorThreshold" }, "floor_effective_rate": { "$ref": "#/components/schemas/FloorEffectiveRate" } }, "description": "Cap and floor thresholds for the interest plan", "example": { "interest_thresholds": { "cap_threshold": 1.1, "cap_effective_rate": 1.2, "floor_threshold": 2.2, "floor_effective_rate": 2.1 } } }, "Margin": { "type": "number", "format": "double", "description": "Also known as a spread, this is an incremental rate the clients receive on investments or deposits. \nIf a `benchmark` value is provided, this field is optional.\nIf `benchmark` is null, this field must be null also.\n", "example": 0.02 }, "MarginRate": { "type": "number", "format": "double", "description": "Rate linked to the benchmark rate. For example, for 110% FED, margin rate is 110%. If a `benchmark` value is not provided, this field must be null.", "example": 1.1 }, "StartDateForNewVersion": { "type": "string", "format": "date", "description": "Date to start applying the new interest plan version. Format = YYYY-MM-DD. Must be greater than or equal to current date.", "example": "2025-06-17" }, "TierCalculation": { "type": "string", "description": "Tier calculation method\n- `RETROACTIVE`: Interest is recalculated from the beginning based on the new applicable rate.\n- `NON-RETROACTIVE`: Interest is calculated progressively based on each layer rate.\n", "enum": [ "RETROACTIVE", "NON-RETROACTIVE" ], "example": "RETROACTIVE" } }, "securitySchemes": { "BearerAuth": { "type": "http", "scheme": "bearer", "bearerFormat": "JWT" } }, "responses": { "400BadRequest": { "description": "Bad request" }, "404NotFound": { "description": "Not found" }, "409Conflict": { "description": "Conflict - A version with this start_date already exists" }, "500InternalServerError": { "description": "Internal server error" } } }, "security": [ { "BearerAuth": [] } ], "paths": { "/v1/interest/plan/{interestPlanId}": { "patch": { "summary": "Create interest plan version", "description": "Create a new version of an existing interest plan. This endpoint allows you to update specific fields while preserving others from the previous version. \n\nKey features:\n- Creates a new version with the specified `start_date`.\n- Updates only the provided fields—any field not specified inherits the value from the previous version.\n- Validates that the new `start_date` is after the `start_date` of the previous version.\n- Maintains immutable fields like `interest_type` and `tier_calculation`.\n- Preserves existing tiers when updating `interest_by_tiers`—only specified tiers are updated.\n\nThis endpoint generates an [Interest plan created](https://developers.pismo.io/events/docs/interest-engine-interest-plan-creation-success-1) event.\n", "tags": [ "Interest engine" ], "operationId": "patch-v1-interest-plan", "parameters": [ { "$ref": "#/components/parameters/Authorization" }, { "$ref": "#/components/parameters/ContentType" }, { "$ref": "#/components/parameters/InterestPlanIdPath" } ], "requestBody": { "description": "Request body", "required": true, "content": { "application/json": { "schema": { "$ref": "#/components/schemas/InterestPlanVersionRequest" } } } }, "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/InterestPlanVersionResponse" } } } }, "400": { "$ref": "#/components/responses/400BadRequest" }, "404": { "$ref": "#/components/responses/404NotFound" }, "409": { "$ref": "#/components/responses/409Conflict" }, "500": { "$ref": "#/components/responses/500InternalServerError" } } } } } } ```